﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography.X509Certificates;
using System.IO;
using System.Net.Security;
using System.Net;
using System.Web;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
namespace Api_demo
{
    /// <summary>
    /// 基础类
    /// </summary>
    class Api
    {
        private string _sercrt_para;
        public string get_secret_log
        {
            get { return _sercrt_para; }
        }
        private string _post_data_log;
        public string get_post_para
        {
            get { return _post_data_log; }
        }



        private string get_timestamp()
        {
            return DateTime.Now.ToString("yyyyMMddHHmmss");
        }
        /// <summary>
        /// 计算32位MD5码
        /// </summary>
        /// <param name="word">字符串</param>
        /// <param name="toUpper">返回哈希值格式 true：英文大写，false：英文小写</param>
        /// <returns></returns>
        private string Hash_MD5_32(string word, bool toUpper = true)
        {
            try
            {
                System.Security.Cryptography.MD5CryptoServiceProvider MD5CSP
                 = new System.Security.Cryptography.MD5CryptoServiceProvider();
                byte[] bytValue = System.Text.Encoding.UTF8.GetBytes(word);
                byte[] bytHash = MD5CSP.ComputeHash(bytValue);
                MD5CSP.Clear();
                //根据计算得到的Hash码翻译为MD5码
                string sHash = "", sTemp = "";
                for (int counter = 0; counter < bytHash.Count(); counter++)
                {
                    long i = bytHash[counter] / 16;
                    if (i > 9)
                    {
                        sTemp = ((char)(i - 10 + 0x41)).ToString();
                    }
                    else
                    {
                        sTemp = ((char)(i + 0x30)).ToString();
                    }
                    i = bytHash[counter] % 16;
                    if (i > 9)
                    {
                        sTemp += ((char)(i - 10 + 0x41)).ToString();
                    }
                    else
                    {
                        sTemp += ((char)(i + 0x30)).ToString();
                    }
                    sHash += sTemp;
                }
                //根据大小写规则决定返回的字符串
                return toUpper ? sHash : sHash.ToLower();
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
        /// <summary>
        /// 返回空，失败
        /// </summary>
        /// <returns></returns>
        protected string Get_Response(Dictionary<string, string> dic, string url, string token_or_pwd)
        {
            try
            {
                string timestamp = get_timestamp();
                dic.Add("timestamp", timestamp);
                dic.Add("appver", "1");
                string[] temp = new string[dic.Count];
                for (int i = 0; i < dic.Count; i++)
                {
                    KeyValuePair<string, string> kv = dic.ElementAt(i);
                    temp[i] = kv.Key + HttpUtility.UrlEncode(kv.Value);
                }
                Array.Sort(temp);
                string _secret = string.Empty;
                for (int i = 0; i < temp.Length; i++)
                {
                    _secret += temp[i];
                }

                _secret += token_or_pwd;

                _sercrt_para = _secret;
                string secret = Hash_MD5_32(_secret);

               

                string post_data = string.Empty;
                foreach (KeyValuePair<string, string> kv in dic)
                {
                    post_data += kv.Key + "=" + HttpUtility.UrlEncode(kv.Value) + "&";
                }

                post_data += "secret=" + secret;

                _post_data_log = post_data;


                string result = string.Empty;

                bool isok = sendHttpPost(out result, url, post_data, null);
                if (isok)
                {
                   
                    return result;
                }
                else
                {

                }

                return string.Empty;
            }
            catch (Exception ex)
            {

                Console.WriteLine(ex.Message);
                return string.Empty;
            }
        }


        /// <summary>
        /// 以json字符串的形式返回服务器内容,默认使用utf-8编码
        /// </summary>
        /// <param name="redata">返回的数据</param>
        /// <param name="serviceAddress">服务器器地址</param>
        /// <param name="reqToken">token</param>
        /// <returns></returns>
        private static bool sendHttpGet(out string redata, string serviceAddress, string reqToken)
        {
            try
            {
                if (serviceAddress.Length <= 0)
                {
                    redata = null;
                    return false;
                }
                // Encoding encode = Encoding.GetEncoding(encodeType);
                // HttpWebRequest request = (HttpWebRequest)HttpWebRequest.Create(serviceAddress);

                //添加https兼容处理
                HttpWebRequest request = null;
                if (serviceAddress.StartsWith("https", StringComparison.OrdinalIgnoreCase))
                {
                    // 这里设置了协议类型。把SSL验证的设置写到HttpRequect创建之前
                    ServicePointManager.ServerCertificateValidationCallback = new RemoteCertificateValidationCallback(CheckValidationResult);
                    ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3 | SecurityProtocolType.Tls;
                    ServicePointManager.CheckCertificateRevocationList = true;
                    ServicePointManager.DefaultConnectionLimit = 100;
                    ServicePointManager.Expect100Continue = true;

                    request = WebRequest.Create(serviceAddress) as HttpWebRequest;
                    request.ProtocolVersion = HttpVersion.Version11;
                    request.KeepAlive = false;
                }
                else
                {
                    request = (HttpWebRequest)WebRequest.Create(serviceAddress);
                }

                if (null != reqToken && reqToken.Length > 0)
                {
                    request.Headers.Add("Authorization", reqToken);
                }
                request.Method = "GET";
                request.ContentType = "application/json";
                request.Timeout = 300000;
                request.ServicePoint.ConnectionLimit = 50;
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                string strResponse = string.Empty;

                //读取返回数据流
                if ("gzip".Equals(response.ContentEncoding))
                {
                    using (Stream responseStream = new System.IO.Compression.GZipStream(response.GetResponseStream(), System.IO.Compression.CompressionMode.Decompress))
                    {
                        if (responseStream != null)
                        {
                            StreamReader streamReader = new StreamReader(responseStream, Encoding.GetEncoding(response.CharacterSet));
                            strResponse = streamReader.ReadToEnd().Trim();
                        }
                        else
                        {
                            redata = null;
                            return false;
                        }
                    }
                }
                else if ("deflate".Equals(response.ContentEncoding))
                {
                    using (Stream responseStream = new System.IO.Compression.DeflateStream(response.GetResponseStream(), System.IO.Compression.CompressionMode.Decompress))
                    {
                        if (responseStream != null)
                        {
                            StreamReader streamReader = new StreamReader(responseStream, Encoding.GetEncoding(response.CharacterSet));
                            strResponse = streamReader.ReadToEnd().Trim();
                        }
                        else
                        {
                            redata = null;
                            return false;
                        }
                    }
                }
                else
                {
                    using (Stream responseStream = response.GetResponseStream())
                    {
                        if (responseStream != null)
                        {
                            StreamReader streamReader = new StreamReader(responseStream, Encoding.GetEncoding(response.CharacterSet));
                            strResponse = streamReader.ReadToEnd().Trim();
                        }
                        else
                        {
                            redata = null;
                            return false;
                        }
                    }
                }
                redata = strResponse;
                return true;
            }
            catch (Exception ex)
            {
                redata = null;

                return false;
            }
        }

        /// <summary>
        /// 以json字符串的形式返回服务器内容,默认使用utf-8编码
        /// </summary>
        /// <param name="redata">返回的数据</param>
        /// <param name="serviceAddress">服务器器地址</param>
        /// <param name="postContent">提交的参数</param>
        /// <returns></returns>
        private static bool sendHttpPost(out string redata, string serviceAddress, string postContent, string reqToken)
        {
            try
            {
                if (serviceAddress.Length <= 0)
                {
                    redata = null;
                    return false;
                }
                // Encoding encode = Encoding.GetEncoding(encodeType);
                // HttpWebRequest request = (HttpWebRequest)HttpWebRequest.Create(serviceAddress);

                //添加https兼容处理
                HttpWebRequest request = null;
                if (serviceAddress.StartsWith("https", StringComparison.OrdinalIgnoreCase))
                {
                    // 这里设置了协议类型。把SSL验证的设置写到HttpRequect创建之前
                    ServicePointManager.ServerCertificateValidationCallback = new RemoteCertificateValidationCallback(CheckValidationResult);
                    ServicePointManager.SecurityProtocol = (SecurityProtocolType)192 | (SecurityProtocolType)768 | (SecurityProtocolType)3072;
                    ServicePointManager.CheckCertificateRevocationList = true;
                    ServicePointManager.DefaultConnectionLimit = 100;
                    ServicePointManager.Expect100Continue = true;

                    request = WebRequest.Create(serviceAddress) as HttpWebRequest;
                    request.ProtocolVersion = HttpVersion.Version11;
                    request.KeepAlive = false;
                }
                else
                {
                    request = (HttpWebRequest)WebRequest.Create(serviceAddress);
                }

                request.ContentType = "application/x-www-form-urlencoded";

                if (null != reqToken && reqToken.Length > 0)
                {
                    request.Headers.Add("Authorization", reqToken);
                }
                request.Method = "POST";
                //request.ContentType = "application/json";
                request.Timeout = 300000;
                request.ServicePoint.ConnectionLimit = 50;
                string strContent = postContent;
                using (StreamWriter dataStream = new StreamWriter(request.GetRequestStream()))
                {
                    dataStream.Write(strContent);
                    dataStream.Close();
                }

                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                string strResponse = string.Empty;

                //读取返回数据流
                if ("gzip".Equals(response.ContentEncoding))
                {
                    using (Stream responseStream = new System.IO.Compression.GZipStream(response.GetResponseStream(), System.IO.Compression.CompressionMode.Decompress))
                    {
                        if (responseStream != null)
                        {
                            StreamReader streamReader = new StreamReader(responseStream, Encoding.GetEncoding(response.CharacterSet));
                            strResponse = streamReader.ReadToEnd().Trim();
                        }
                        else
                        {
                            redata = null;
                            return false;
                        }
                    }
                }
                else if ("deflate".Equals(response.ContentEncoding))
                {
                    using (Stream responseStream = new System.IO.Compression.DeflateStream(response.GetResponseStream(), System.IO.Compression.CompressionMode.Decompress))
                    {
                        if (responseStream != null)
                        {
                            StreamReader streamReader = new StreamReader(responseStream, Encoding.GetEncoding(response.CharacterSet));
                            strResponse = streamReader.ReadToEnd().Trim();
                        }
                        else
                        {
                            redata = null;
                            return false;
                        }
                    }
                }
                else
                {
                    using (Stream responseStream = response.GetResponseStream())
                    {
                        if (responseStream != null)
                        {
                            StreamReader streamReader = new StreamReader(responseStream, Encoding.GetEncoding(response.CharacterSet));
                            strResponse = streamReader.ReadToEnd().Trim();
                        }
                        else
                        {
                            redata = null;
                            return false;
                        }
                    }
                }
                redata = strResponse;
                return true;
            }
            catch (Exception ex)
            {
                redata = null;

                return false;
            }
        }

        private static bool CheckValidationResult(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors sslPolicyErrors)
        {
            return true; //总是接收
        }

    }

    /// <summary>
    /// 获取token   
    /// </summary>
    class Token : Api
    {
        /// <summary>
        /// 用户名
        /// </summary>
        public string user;
        /// <summary>
        /// 密码
        /// </summary>
        public string pwd_or_Token;
        /// <summary>
        /// 服务器地址
        /// </summary>
        public const string url = "https://xtapi.uincall.com/api/call/union400Login.action";

        /// <summary>
        /// 获取token 返回空，失败，具体可看console输出
        /// </summary>
        /// <returns></returns>
        public string get_token()
        {
            if (user.Trim() == string.Empty || pwd_or_Token.Trim() == string.Empty)
            {
                Console.WriteLine("用户名密码不能为空");
                return string.Empty;
            }
            Dictionary<string, string> dic = new Dictionary<string, string>();
            dic.Add("user", user);

            string result = string.Empty;
            result = base.Get_Response(dic, url, pwd_or_Token);

            JObject obj = JObject.Parse(result);
            if (obj["errcode"].ToString() == "0")

                return obj["data"]["token"].ToString();
            else
                return string.Empty;
        }
    }


    /// <summary>
    /// 企业总机-添加分机
    /// </summary>
    class ZongJi_add : Api
    {
        /// <summary>
        /// 用户名
        /// </summary>
        public string user;
        /// <summary>
        /// 企业400号码
        /// </summary>
        public string account;
        /// <summary>
        /// 格式参照http://developer.uincall.com:8181/docs/mindocmindoc-1ciiumf1lsovd/mindocmindoc-1ciiumf1lsovd-1dm8oi3ncd63b
        /// </summary>
        public string data;
        public string token;
        public const string url = "https://xtapi.uincall.com/api/call/addExtensionV2.action";
        /// <summary>
        /// 返回空失败
        /// </summary>
        /// <returns></returns>
        public string add()
        {
            if (user == null || account == null || data == null || token == null || token == null)
            {
                Console.WriteLine("所有属性都为必填项");
                return string.Empty;
            }
            Dictionary<string, string> dic = new Dictionary<string, string>();
            dic.Add("user", user);
            dic.Add("account", account);
            dic.Add("data", data);
            return base.Get_Response(dic, url, token);




        }


    }
    /// <summary>
    /// 企业总机-查询分机
    /// </summary>
    class ZongJi_query : Api
    {
        /// <summary>
        /// 用户名
        /// </summary>
        public string user;
        /// <summary>
        /// 企业400号码
        /// </summary>
        public string account;
        /// <summary>
        /// 分机编号，查询多个可以用英文逗号分隔，上限500个。
        /// </summary>
        public string dn;
        public string token;
        public const string url = "https://xtapi.uincall.com/api/call/queryExtensionV2.action";
        /// <summary>
        /// 返回空失败
        /// </summary>
        /// <returns></returns>
        public string query()
        {
            if (user == null || account == null || dn == null || token == null)
            {
                Console.WriteLine("所有属性都为必填项");
                return string.Empty;
            }
            Dictionary<string, string> dic = new Dictionary<string, string>();
            dic.Add("user", user);
            dic.Add("account", account);
            dic.Add("dn", dn);

            string result = string.Empty;
            return base.Get_Response(dic, url, token);


        }


    }


    /// <summary>
    /// 企业总机---批量查询
    /// </summary>
    class Zongji_piliang_query : Api
    {
        public const string url = "https://xtapi.uincall.com/api/call/batchQueryExtensionV2.action";
        /// <summary>
        /// 用户名
        /// </summary>
        public string user;
        /// <summary>
        /// 企业400号码
        /// </summary>
        public string account;
        public string pageSize;
        public string pageNow;
        public string token;
        public string piliang_query()
        {
            if (user == null || account == null || pageSize == null || token == null || pageNow == null)
            {
                Console.WriteLine("所有属性都为必填项");
                return string.Empty;
            }
            Dictionary<string, string> dic = new Dictionary<string, string>();
            dic.Add("user", user);
            dic.Add("account", account);
            dic.Add("pageSize", pageSize);
            dic.Add("pageNow", pageNow);


            string result = string.Empty;
            return base.Get_Response(dic, url, token);
        }
    }


    /// <summary>
    /// 虚拟总机删除------异步操作。请在调用时自行处理异步操作，避免因为等待而将主程序阻塞
    /// </summary>
    class zongji_delete : Api
    {
        public const string url = "https://xtapi.uincall.com/api/call/deleteExtensionV2.action";
        /// <summary>
        /// 用户名
        /// </summary>
        public string user;
        /// <summary>
        /// 企业400号码
        /// </summary>
        public string account;
        /// <summary>
        /// 分机编号，查询多个可以用英文逗号分隔，上限500个。
        /// </summary>
        public string dn;
        public string token;
        public string delete()
        {
            if (user == null || account == null || dn == null || token == null)
            {
                Console.WriteLine("所有属性都为必填项");
                return string.Empty;
            }
            Dictionary<string, string> dic = new Dictionary<string, string>();
            dic.Add("user", user);
            dic.Add("account", account);
            dic.Add("dn", dn);

            string result = string.Empty;
            return base.Get_Response(dic, url, token);


        }
    }
    /// <summary>
    /// 虚拟总机分机清空
    /// </summary>
    class zongji_fenji_clear : Api
    {
        public const string url = "http://xtapi.uincall.com/api/call/clearExtensionV2.action";
        /// <summary>
        /// 用户名
        /// </summary>
        public string user;
        /// <summary>
        /// 企业400号码
        /// </summary>
        public string account;
        public string token;
        public string clear()
        {
            if (user == null || account == null || token == null)
            {
                Console.WriteLine("所有属性都为必填项");
                return string.Empty;
            }
            Dictionary<string, string> dic = new Dictionary<string, string>();
            dic.Add("user", user);
            dic.Add("account", account);

            return base.Get_Response(dic, url, token);
        }
    }

    /// <summary>
    /// 通话记录查询
    /// 只支持查询当前 2 个月的通话记录，客户端按时间段查询，保存到客户端本地。
    /// </summary>
    class call_record_query : Api
    {
        public const string url = "https://xtapi.uincall.com/api/call/queryCallRecord.action";
        /// <summary>
        /// 用户名
        /// </summary>
        public string user;
        /// <summary>
        /// 企业400号码
        /// </summary>
        public string account;

        public string startTime;
        public string endTime;
        public string pageSize;
        public string pageNow;
        public string token;
        public string query()
        {
            if (user == null || account == null || startTime == null || endTime == null || pageSize == null || pageNow==null || token ==null )
            {
                Console.WriteLine("所有属性都为必填项");
                return string.Empty;
            }
            Dictionary<string, string> dic = new Dictionary<string, string>();
            dic.Add("user", user);
            dic.Add("account", account);
            dic.Add("startTime", startTime);
            dic.Add("endTime", endTime);
            dic.Add("pageSize", pageSize);
            dic.Add("pageNow", pageNow);
            return base.Get_Response(dic, url, token);
        }
    }

    /// <summary>
    /// 查询呼叫事件
    /// 接口请求后会返回所有的结果，单次返回上限 500 个。提取过的记录，将不会在返回。
    /// </summary>
    class call_event : Api
    {
        public const string url = "https://xtapi.uincall.com/api/call/queryCallEvent.action";
        /// <summary>
        /// 用户名
        /// </summary>
        public string user;
        /// <summary>
        /// 企业400号码
        /// </summary>
        public string account;
        public string token;
        public string query()
        {
            if (user == null || account == null ||  token == null)
            {
                Console.WriteLine("所有属性都为必填项");
                return string.Empty;
            }
            Dictionary<string, string> dic = new Dictionary<string, string>();
            dic.Add("user", user);
            dic.Add("account", account);
        
            return base.Get_Response(dic, url, token);
        }

    }













































}
